
\section{Conclusion and Future Work}
\label{sec:conclusion}

In this paper, we propose GRT, a combined static and run-time-guided technique to
guide random testing without relying on knowledge other than the set of
classes to test.
Our static analysis extracts domain knowledge from the classes under test,
and uses this to guide run-time test generation.
Our run-time phase performs further dynamic analysis to improve
test coverage.
%We implement a prototype of GRT, in which each component 
%functions as a pluggable option to guide random testing. 
We perform thorough evaluations of our implementation on a large set of
real-world projects.
Our approach significantly improves code coverage and bug detection ability.

In future work, we want to consider enhancing the test oracle, as currently
some faulty code is executed without a failure being found.
%%% +++ UPDATE if needed and if space available
%trying
%to find a better set of configuration parameters and making them
%We also want to fine-tune our enhancements,
%to make them better applicable against a given memory limit.
%We will also
%consider a given number of test executions instead of a time interval
%to make our enhancements less platform-dependent.
%We also think GRT can be further improved by fine-tuning some parameters
%of our enhancements.
%Reimplementing the purity analysis as bytecode rather than source code analysis will make
%that step faster, and also usable when the source is unavailable.
%Furthermore, we think that reducing false positives is an important area of future
%work for random testing in general. Simple improvements include options
%to avoid deprecated code or recursive data structures.
Further improvements
include mining the specification and documentation to extract possible
information on valid uses of a system~\cite{6044587, Pradel:2012:LTG:2337223.2337258},
and better test simplification for an easier validation of failed tests.

%As well defined specification also favored automatic testing, which shrinks the input space and possible
%method combinations by making constraints on the valid input domain, 
%method invocations orders such as temporal order, we also discuss some recent works on
%automatic specification mining and its potential usage to guide automatic test case generation.
